
/*
 * Progetto 2 del capitolo 6 del libro Savitch.
 * 
 * Scrivere un programma che legge una riga di testo che termina con un punto,
 * che funge da valore sentinella. 
 * Visualizzare tutte le lettere presenti nel testo, una per riga e in ordine
 * alfabetico, indicando il numero di volte che si presenta nel testo.
 * Utilizzare un array di tipo base int di lunghezza 26, cos che l'elemento
 * all'indice 0 contenga il numero di lettere "a", l'elemento all'indice "1"
 * contenga il numero di lettere "b" e cos via.
 * Considerare come input sia le lettere maiuscole, sia quelle minuscole, ma
 * poi, nel conteggio, considerarle uguali. 
 * Suggerimento: prima di elaborare la riga di testo, utilizzare uno dei metodi
 * toUpperCase() o toLowerCase() della classe String.
 * Potrebbe essere utile definire un metodo che prende come argomento un carattere
 * e restituisce un valore int che corrisponde al corretto indice di quel carattere.
 * Per esempio, l'argomento 'a' restituir 0, l'argomento 'b' restituir 1, e
 * cos via.
 * Si noti che  possibile utilizzare una conversione di tipo, come (int)lettera,
 * per trasformare un char in int. Sicuramente questo non avr il valore 
 * desiderato, ma se si sottrae (int)'a', si avr l'indice corretto.
 * Infine si permetta all'utente di ripetere queste operazioni finch vuole.
 * 
 * NOTA: l'espressione (int)'a' restituisce la conversione a intero del carattere 'a',
 * ossia l'intero corrispondente alla sua codifica ASCII. 
 * Per il carattere 'a' tale valore corrisponde all'intero 97, per 'b'  98, ecc.
 * 
 */

import java.util.*;

public class TestoDiCaratteri {
	
	public static final int NUM_CARATTERI = 26;
	
	public static void main(String[] args) {
		
		Scanner tastiera = new Scanner(System.in);
		String risposta;
		
		do {
			int[] occorrenzeCarattere = new int[NUM_CARATTERI];
			System.out.println("Inserire una riga di testo terminata con un punto:");
			String testo = tastiera.nextLine().toLowerCase().replaceAll(" ", ""); // eliminiamo gli spazi
			for(int i=0; i<testo.length()-1; i++) { // length()-1 perch devo escludere il punto finale
				// incremento il numero di occorrenze del carattere corrispondente nel vettore
				// trovo la posizione nel vettore tramite il metodo posizioneCarattere
				occorrenzeCarattere[posizioneCarattere(testo.charAt(i))]++;
			}
			
			stampa(occorrenzeCarattere);
			System.out.println("Vuoi continuare (SI/NO)?");
			risposta = tastiera.next();
			tastiera.nextLine();
		}while(risposta.equalsIgnoreCase("si"));
		
		tastiera.close();
	}
	
	// questo metodo determina quale posizione del vettore dei caratteri  associato al carattere dato:
	// il carattere 'a' sar associato alla posizione 0, il carattere 'b' alla posizione 1, ecc.. 
	public static int posizioneCarattere(char c) {
		// il risultato si basa sulla differenza delle codifiche ASCII dei caratteri.
		// Ad esempio, se c fosse il carattere 'a', l'espressione qui sotto darebbe come risultato 0 
		// (ossia 97-97, in quanto la codifica ASCII di 'a' 97).
		// se c fosse il carattere 'b', l'espressione darebbe come risultato 1 (ossia 98-97, in quanto
		// la codifica ASCII di 'b'  98), ecc.
		return (int)c - (int)'a';
	}

	public static void stampa(int[] vettore) {
		for(int i=0; i < vettore.length; i++)
			// qui si svolge l'operazione contraria a quella del metodo posizioneCarattere,
			// ossia di ricostruisce il carattere partendo dalla sua codifica ASCII e convertendo
			// tale codifica intera nel corrispodente carattere tramite il cast a char.
			// Poich i parte da 0, alla prima iterazione l'espressione (i+(int)'a') equivale a (0+97)
			// ossia 97, quindi il cast a char di 97 restituisce il carattere codificato in ASCII
			// con 97, ossia 'a'. 
			// Per le iterazioni successive, all'aumentare di i, i valori dell'espressione (i+(int)'a')
			// avanzeranno di una unit e quindi il cast a char restituir i caratteri alfabeticamente
			// successivi ad 'a' (ad es.: per i=1, (i+(int)'a')=(1+97)=98 e il cast a char di 98  'b'.
			System.out.println("Lettera "+ (char)(i+(int)'a')+": "+vettore[i]+" occorrenze");
	};
	
}
